diff --git a/salt/modules/virt.py b/salt/modules/virt.py
index c8e046a47a..a78c21e323 100644
--- a/salt/modules/virt.py
+++ b/salt/modules/virt.py
@@ -1939,52 +2354,79 @@ def update(name,
             if parent_tag is not None:
                 child_tag = ElementTree.SubElement(parent_tag, tag)
             else:
-                new_parent_tag = ElementTree.Element('os')
+                new_parent_tag = ElementTree.Element("os")
                 child_tag = ElementTree.SubElement(new_parent_tag, tag)
 
             child_tag.text = boot_tag_value
+
+            # If the newly created tag is loader or nvram, we need to update the corresponding attribute
+            if child_tag.tag == "loader":
+                child_tag.set("readonly", "yes")
+                child_tag.set("type", "pflash")
+
+            if child_tag.tag == "nvram":
+                child_tag.set("template", child_tag.text)
+                child_tag.text = None
+
             need_update = True
 
     # Update the memory, note that libvirt outputs all memory sizes in KiB
-    for mem_node_name in ['memory', 'currentMemory']:
+    for mem_node_name in ["memory", "currentMemory"]:
         mem_node = desc.find(mem_node_name)
         if mem and int(mem_node.text) != mem * 1024:
             mem_node.text = six.text_type(mem)
-            mem_node.set('unit', 'MiB')
+            mem_node.set("unit", "MiB")
             need_update = True
 
     # Update the XML definition with the new disks and diff changes
-    devices_node = desc.find('devices')
-    parameters = {'disk': ['disks', 'disk_profile'],
-                  'interface': ['interfaces', 'nic_profile'],
-                  'graphics': ['graphics']}
+    devices_node = desc.find("devices")
+    parameters = {
+        "disk": ["disks", "disk_profile"],
+        "interface": ["interfaces", "nic_profile"],
+        "graphics": ["graphics"],
+    }
     changes = {}
     for dev_type in parameters:
         changes[dev_type] = {}
         func_locals = locals()
-        if [param for param in parameters[dev_type] if func_locals.get(param, None) is not None]:
+        if [
+            param
+            for param in parameters[dev_type]
+            if func_locals.get(param, None) is not None
+        ]:
             old = devices_node.findall(dev_type)
-            new = new_desc.findall('devices/{0}'.format(dev_type))
-            changes[dev_type] = globals()['_diff_{0}_lists'.format(dev_type)](old, new)
-            if changes[dev_type]['deleted'] or changes[dev_type]['new']:
+            new = new_desc.findall("devices/{0}".format(dev_type))
+            changes[dev_type] = globals()["_diff_{0}_lists".format(dev_type)](old, new)
+            if changes[dev_type]["deleted"] or changes[dev_type]["new"]:
                 for item in old:
                     devices_node.remove(item)
-                devices_node.extend(changes[dev_type]['sorted'])
+                devices_node.extend(changes[dev_type]["sorted"])
                 need_update = True
 
     # Set the new definition
     if need_update:
         # Create missing disks if needed
-        if changes['disk']:
-            for idx, item in enumerate(changes['disk']['sorted']):
-                source_file = all_disks[idx]['source_file']
-                if item in changes['disk']['new'] and source_file and not os.path.isfile(source_file) and not test:
-                    _qemu_image_create(all_disks[idx])
-
         try:
+            if changes["disk"]:
+                for idx, item in enumerate(changes["disk"]["sorted"]):
+                    source_file = all_disks[idx].get("source_file")
+                    # We don't want to create image disks for cdrom devices
+                    if all_disks[idx].get("device", "disk") == "cdrom":
+                        continue
+                    if (
+                        item in changes["disk"]["new"]
+                        and source_file
+                        and not os.path.isfile(source_file)
+                    ):
+                        _qemu_image_create(all_disks[idx])
+                    elif item in changes["disk"]["new"] and not source_file:
+                        _disk_volume_create(conn, all_disks[idx])
+
             if not test:
-                conn.defineXML(salt.utils.stringutils.to_str(ElementTree.tostring(desc)))
-            status['definition'] = True
+                conn.defineXML(
+                    salt.utils.stringutils.to_str(ElementTree.tostring(desc))
+                )
+            status["definition"] = True
         except libvirt.libvirtError as err:
             conn.close()
             raise err
@@ -1993,48 +2435,133 @@ def update(name,
         # From that point on, failures are not blocking to try to live update as much
         # as possible.
         commands = []
+        removable_changes = []
         if domain.isActive() and live:
             if cpu:
-                commands.append({'device': 'cpu',
-                                 'cmd': 'setVcpusFlags',
-                                 'args': [cpu, libvirt.VIR_DOMAIN_AFFECT_LIVE]})
+                commands.append(
+                    {
+                        "device": "cpu",
+                        "cmd": "setVcpusFlags",
+                        "args": [cpu, libvirt.VIR_DOMAIN_AFFECT_LIVE],
+                    }
+                )
             if mem:
-                commands.append({'device': 'mem',
-                                 'cmd': 'setMemoryFlags',
-                                 'args': [mem * 1024, libvirt.VIR_DOMAIN_AFFECT_LIVE]})
+                commands.append(
+                    {
+                        "device": "mem",
+                        "cmd": "setMemoryFlags",
+                        "args": [mem * 1024, libvirt.VIR_DOMAIN_AFFECT_LIVE],
+                    }
+                )
 
-            for dev_type in ['disk', 'interface']:
-                for added in changes[dev_type].get('new', []):
-                    commands.append({'device': dev_type,
-                                     'cmd': 'attachDevice',
-                                     'args': [salt.utils.stringutils.to_str(ElementTree.tostring(added))]})
+            # Look for removable device source changes
+            new_disks = []
+            for new_disk in changes["disk"].get("new", []):
+                device = new_disk.get("device", "disk")
+                if device not in ["cdrom", "floppy"]:
+                    new_disks.append(new_disk)
+                    continue
+
+                target_dev = new_disk.find("target").get("dev")
+                matching = [
+                    old_disk
+                    for old_disk in changes["disk"].get("deleted", [])
+                    if old_disk.get("device", "disk") == device
+                    and old_disk.find("target").get("dev") == target_dev
+                ]
+                if not matching:
+                    new_disks.append(new_disk)
+                else:
+                    # libvirt needs to keep the XML exactly as it was before
+                    updated_disk = matching[0]
+                    changes["disk"]["deleted"].remove(updated_disk)
+                    removable_changes.append(updated_disk)
+                    source_node = updated_disk.find("source")
+                    new_source_node = new_disk.find("source")
+                    source_file = (
+                        new_source_node.get("file")
+                        if new_source_node is not None
+                        else None
+                    )
+
+                    updated_disk.set("type", "file")
+                    # Detaching device
+                    if source_node is not None:
+                        updated_disk.remove(source_node)
+
+                    # Attaching device
+                    if source_file:
+                        ElementTree.SubElement(
+                            updated_disk, "source", attrib={"file": source_file}
+                        )
+
+            changes["disk"]["new"] = new_disks
+
+            for dev_type in ["disk", "interface"]:
+                for added in changes[dev_type].get("new", []):
+                    commands.append(
+                        {
+                            "device": dev_type,
+                            "cmd": "attachDevice",
+                            "args": [
+                                salt.utils.stringutils.to_str(
+                                    ElementTree.tostring(added)
+                                )
+                            ],
+                        }
+                    )
+
+                for removed in changes[dev_type].get("deleted", []):
+                    commands.append(
+                        {
+                            "device": dev_type,
+                            "cmd": "detachDevice",
+                            "args": [
+                                salt.utils.stringutils.to_str(
+                                    ElementTree.tostring(removed)
+                                )
+                            ],
+                        }
+                    )
 
-                for removed in changes[dev_type].get('deleted', []):
-                    commands.append({'device': dev_type,
-                                     'cmd': 'detachDevice',
-                                     'args': [salt.utils.stringutils.to_str(ElementTree.tostring(removed))]})
+        for updated_disk in removable_changes:
+            commands.append(
+                {
+                    "device": "disk",
+                    "cmd": "updateDeviceFlags",
+                    "args": [
+                        salt.utils.stringutils.to_str(
+                            ElementTree.tostring(updated_disk)
+                        )
+                    ],
+                }
+            )
 
         for cmd in commands:
             try:
-                ret = getattr(domain, cmd['cmd'])(*cmd['args']) if not test else 0
-                device_type = cmd['device']
-                if device_type in ['cpu', 'mem']:
+                ret = getattr(domain, cmd["cmd"])(*cmd["args"]) if not test else 0
+                device_type = cmd["device"]
+                if device_type in ["cpu", "mem"]:
                     status[device_type] = not bool(ret)
                 else:
-                    actions = {'attachDevice': 'attached', 'detachDevice': 'detached'}
-                    status[device_type][actions[cmd['cmd']]].append(cmd['args'][0])
+                    actions = {
+                        "attachDevice": "attached",
+                        "detachDevice": "detached",
+                        "updateDeviceFlags": "updated",
+                    }
+                    status[device_type][actions[cmd["cmd"]]].append(cmd["args"][0])
 
             except libvirt.libvirtError as err:
-                if 'errors' not in status:
-                    status['errors'] = []
-                status['errors'].append(six.text_type(err))
+                if "errors" not in status:
+                    status["errors"] = []
+                status["errors"].append(six.text_type(err))
 
     conn.close()
     return status
 
 
 def list_domains(**kwargs):
-    '''
+    """
     Return a list of available domains.
 
     :param connection: libvirt connection URI, overriding defaults
@@ -2052,7 +2579,7 @@ def list_domains(**kwargs):
     .. code-block:: bash
 
         salt '*' virt.list_domains
-    '''
+    """
     vms = []
     conn = __get_conn(**kwargs)
     for dom in _get_domain(conn, iterable=True):
@@ -2062,7 +2589,7 @@ def list_domains(**kwargs):
 
 
 def list_active_vms(**kwargs):
-    '''
+    """
     Return a list of names for active virtual machine on the minion
 
     :param connection: libvirt connection URI, overriding defaults
@@ -2080,7 +2607,7 @@ def list_active_vms(**kwargs):
     .. code-block:: bash
 
         salt '*' virt.list_active_vms
-    '''
+    """
     vms = []
     conn = __get_conn(**kwargs)
     for dom in _get_domain(conn, iterable=True, inactive=False):
@@ -2090,7 +2617,7 @@ def list_active_vms(**kwargs):
 
 
 def list_inactive_vms(**kwargs):
-    '''
+    """
     Return a list of names for inactive virtual machine on the minion
 
     :param connection: libvirt connection URI, overriding defaults
@@ -2108,7 +2635,7 @@ def list_inactive_vms(**kwargs):
     .. code-block:: bash
 
         salt '*' virt.list_inactive_vms
-    '''
+    """
     vms = []
     conn = __get_conn(**kwargs)
     for dom in _get_domain(conn, iterable=True, active=False):
@@ -2118,7 +2645,7 @@ def list_inactive_vms(**kwargs):
 
 
 def vm_info(vm_=None, **kwargs):
-    '''
+    """
     Return detailed information about the vms on this hyper in a
     list of dicts:
 
@@ -2153,38 +2680,43 @@ def vm_info(vm_=None, **kwargs):
 
     .. code-block:: bash
 
-        salt '*' virt.vm_info
-    '''
-    def _info(dom):
-        '''
+        salt '*' virt.vm_info
+    """
+
+    def _info(conn, dom):
+        """
         Compute the infos of a domain
-        '''
+        """
         raw = dom.info()
-        return {'cpu': raw[3],
-                'cputime': int(raw[4]),
-                'disks': _get_disks(dom),
-                'graphics': _get_graphics(dom),
-                'nics': _get_nics(dom),
-                'uuid': _get_uuid(dom),
-                'on_crash': _get_on_crash(dom),
-                'on_reboot': _get_on_reboot(dom),
-                'on_poweroff': _get_on_poweroff(dom),
-                'maxMem': int(raw[1]),
-                'mem': int(raw[2]),
-                'state': VIRT_STATE_NAME_MAP.get(raw[0], 'unknown')}
+        return {
+            "cpu": raw[3],
+            "cputime": int(raw[4]),
+            "disks": _get_disks(conn, dom),
+            "graphics": _get_graphics(dom),
+            "nics": _get_nics(dom),
+            "uuid": _get_uuid(dom),
+            "loader": _get_loader(dom),
+            "on_crash": _get_on_crash(dom),
+            "on_reboot": _get_on_reboot(dom),
+            "on_poweroff": _get_on_poweroff(dom),
+            "maxMem": int(raw[1]),
+            "mem": int(raw[2]),
+            "state": VIRT_STATE_NAME_MAP.get(raw[0], "unknown"),
+        }
+
     info = {}
     conn = __get_conn(**kwargs)
     if vm_:
-        info[vm_] = _info(_get_domain(conn, vm_))
+        info[vm_] = _info(conn, _get_domain(conn, vm_))
     else:
         for domain in _get_domain(conn, iterable=True):
-            info[domain.name()] = _info(domain)
+            info[domain.name()] = _info(conn, domain)
     conn.close()
     return info
 
 
 def vm_state(vm_=None, **kwargs):
-    '''
+    """
     Return list of all the vms and their state.
 
     If you pass a VM name in as an argument then it will return info
@@ -2206,15 +2738,17 @@ def vm_state(vm_=None, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.vm_state <domain>
-    '''
+    """
+
     def _info(dom):
-        '''
+        """
         Compute domain state
-        '''
-        state = ''
+        """
+        state = ""
         raw = dom.info()
-        state = VIRT_STATE_NAME_MAP.get(raw[0], 'unknown')
+        state = VIRT_STATE_NAME_MAP.get(raw[0], "unknown")
         return state
+
     info = {}
     conn = __get_conn(**kwargs)
     if vm_:
@@ -2227,23 +2761,25 @@ def vm_state(vm_=None, **kwargs):
 
 
 def _node_info(conn):
-    '''
+    """
     Internal variant of node_info taking a libvirt connection as parameter
-    '''
+    """
     raw = conn.getInfo()
-    info = {'cpucores': raw[6],
-            'cpumhz': raw[3],
-            'cpumodel': six.text_type(raw[0]),
-            'cpus': raw[2],
-            'cputhreads': raw[7],
-            'numanodes': raw[4],
-            'phymemory': raw[1],
-            'sockets': raw[5]}
+    info = {
+        "cpucores": raw[6],
+        "cpumhz": raw[3],
+        "cpumodel": six.text_type(raw[0]),
+        "cpus": raw[2],
+        "cputhreads": raw[7],
+        "numanodes": raw[4],
+        "phymemory": raw[1],
+        "sockets": raw[5],
+    }
     return info
 
 
 def node_info(**kwargs):
-    '''
+    """
     Return a dict with information about this node
 
     :param connection: libvirt connection URI, overriding defaults
@@ -2261,7 +2797,7 @@ def node_info(**kwargs):
     .. code-block:: bash
 
         salt '*' virt.node_info
-    '''
+    """
     conn = __get_conn(**kwargs)
     info = _node_info(conn)
     conn.close()
@@ -2269,7 +2805,7 @@ def node_info(**kwargs):
 
 
 def get_nics(vm_, **kwargs):
-    '''
+    """
     Return info about the network interfaces of a named vm
 
     :param vm_: name of the domain
@@ -2288,7 +2824,7 @@ def get_nics(vm_, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.get_nics <domain>
-    '''
+    """
     conn = __get_conn(**kwargs)
     nics = _get_nics(_get_domain(conn, vm_))
     conn.close()
@@ -2296,7 +2832,7 @@ def get_nics(vm_, **kwargs):
 
 
 def get_macs(vm_, **kwargs):
-    '''
+    """
     Return a list off MAC addresses from the named vm
 
     :param vm_: name of the domain
@@ -2315,13 +2851,13 @@ def get_macs(vm_, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.get_macs <domain>
-    '''
+    """
     doc = ElementTree.fromstring(get_xml(vm_, **kwargs))
-    return [node.get('address') for node in doc.findall('devices/interface/mac')]
+    return [node.get("address") for node in doc.findall("devices/interface/mac")]
 
 
 def get_graphics(vm_, **kwargs):
-    '''
+    """
     Returns the information on vnc for a given vm
 
     :param vm_: name of the domain
@@ -2340,15 +2876,40 @@ def get_graphics(vm_, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.get_graphics <domain>
-    '''
+    """
     conn = __get_conn(**kwargs)
     graphics = _get_graphics(_get_domain(conn, vm_))
     conn.close()
     return graphics
 
 
+def get_loader(vm_, **kwargs):
+    """
+    Returns the information on the loader for a given vm
+
+    :param vm_: name of the domain
+    :param connection: libvirt connection URI, overriding defaults
+    :param username: username to connect with, overriding defaults
+    :param password: password to connect with, overriding defaults
+
+    CLI Example:
+
+    .. code-block:: bash
+
+        salt '*' virt.get_loader <domain>
+
+    .. versionadded:: Fluorine
+    """
+    conn = __get_conn(**kwargs)
+    try:
+        loader = _get_loader(_get_domain(conn, vm_))
+        return loader
+    finally:
+        conn.close()
+
+
 def get_disks(vm_, **kwargs):
-    '''
+    """
     Return the disks of a named vm
 
     :param vm_: name of the domain
@@ -2367,15 +2928,15 @@ def get_disks(vm_, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.get_disks <domain>
-    '''
+    """
     conn = __get_conn(**kwargs)
-    disks = _get_disks(_get_domain(conn, vm_))
+    disks = _get_disks(conn, _get_domain(conn, vm_))
     conn.close()
     return disks
 
 
 def setmem(vm_, memory, config=False, **kwargs):
-    '''
+    """
     Changes the amount of memory allocated to VM. The VM must be shutdown
     for this to work.
 
@@ -2398,11 +2959,11 @@ def setmem(vm_, memory, config=False, **kwargs):
 
         salt '*' virt.setmem <domain> <size>
         salt '*' virt.setmem my_domain 768
-    '''
+    """
     conn = __get_conn(**kwargs)
     dom = _get_domain(conn, vm_)
 
-    if VIRT_STATE_NAME_MAP.get(dom.info()[0], 'unknown') != 'shutdown':
+    if VIRT_STATE_NAME_MAP.get(dom.info()[0], "unknown") != "shutdown":
         return False
 
     # libvirt has a funny bitwise system for the flags in that the flag
@@ -2422,7 +2983,7 @@ def setmem(vm_, memory, config=False, **kwargs):
 
 
 def setvcpus(vm_, vcpus, config=False, **kwargs):
-    '''
+    """
     Changes the amount of vcpus allocated to VM. The VM must be shutdown
     for this to work.
 
@@ -2447,11 +3008,11 @@ def setvcpus(vm_, vcpus, config=False, **kwargs):
 
         salt '*' virt.setvcpus <domain> <amount>
         salt '*' virt.setvcpus my_domain 4
-    '''
+    """
     conn = __get_conn(**kwargs)
     dom = _get_domain(conn, vm_)
 
-    if VIRT_STATE_NAME_MAP.get(dom.info()[0], 'unknown') != 'shutdown':
+    if VIRT_STATE_NAME_MAP.get(dom.info()[0], "unknown") != "shutdown":
         return False
 
     # see notes in setmem
@@ -2468,9 +3029,9 @@ def setvcpus(vm_, vcpus, config=False, **kwargs):
 
 
 def _freemem(conn):
-    '''
+    """
     Internal variant of freemem taking a libvirt connection as parameter
-    '''
+    """
     mem = conn.getInfo()[1]
     # Take off just enough to sustain the hypervisor
     mem -= 256
@@ -2481,7 +3042,7 @@ def _freemem(conn):
 
 
 def freemem(**kwargs):
-    '''
+    """
     Return an int representing the amount of memory (in MB) that has not
     been given to virtual machines on this node
 
@@ -2500,7 +3061,7 @@ def freemem(**kwargs):
     .. code-block:: bash
 
         salt '*' virt.freemem
-    '''
+    """
     conn = __get_conn(**kwargs)
     mem = _freemem(conn)
     conn.close()
@@ -2508,9 +3069,9 @@ def freemem(**kwargs):
 
 
 def _freecpu(conn):
-    '''
+    """
     Internal variant of freecpu taking a libvirt connection as parameter
-    '''
+    """
     cpus = conn.getInfo()[2]
     for dom in _get_domain(conn, iterable=True):
         if dom.ID() > 0:
@@ -2519,7 +3080,7 @@ def _freecpu(conn):
 
 
 def freecpu(**kwargs):
-    '''
+    """
     Return an int representing the number of unallocated cpus on this
     hypervisor
 
@@ -2538,7 +3099,7 @@ def freecpu(**kwargs):
     .. code-block:: bash
 
         salt '*' virt.freecpu
-    '''
+    """
     conn = __get_conn(**kwargs)
     cpus = _freecpu(conn)
     conn.close()
@@ -2546,7 +3107,7 @@ def freecpu(**kwargs):
 
 
 def full_info(**kwargs):
-    '''
+    """
     Return the node_info, vm_info and freemem
 
     :param connection: libvirt connection URI, overriding defaults
@@ -2564,18 +3125,20 @@ def full_info(**kwargs):
     .. code-block:: bash
 
         salt '*' virt.full_info
-    '''
+    """
     conn = __get_conn(**kwargs)
-    info = {'freecpu': _freecpu(conn),
-            'freemem': _freemem(conn),
-            'node_info': _node_info(conn),
-            'vm_info': vm_info()}
+    info = {
+        "freecpu": _freecpu(conn),
+        "freemem": _freemem(conn),
+        "node_info": _node_info(conn),
+        "vm_info": vm_info(),
+    }
     conn.close()
     return info
 
 
 def get_xml(vm_, **kwargs):
-    '''
+    """
     Returns the XML for a given vm
 
     :param vm_: domain name
@@ -2594,17 +3157,19 @@ def get_xml(vm_, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.get_xml <domain>
-    '''
+    """
     conn = __get_conn(**kwargs)
-    xml_desc = vm_.XMLDesc(0) if isinstance(
-        vm_, libvirt.virDomain
-    ) else _get_domain(conn, vm_).XMLDesc(0)
+    xml_desc = (
+        vm_.XMLDesc(0)
+        if isinstance(vm_, libvirt.virDomain)
+        else _get_domain(conn, vm_).XMLDesc(0)
+    )
     conn.close()
     return xml_desc
 
 
 def get_profiles(hypervisor=None, **kwargs):
-    '''
+    """
     Return the virt profiles for hypervisor.
 
     Currently there are profiles for:
@@ -2629,40 +3194,42 @@ def get_profiles(hypervisor=None, **kwargs):
 
         salt '*' virt.get_profiles
         salt '*' virt.get_profiles hypervisor=esxi
-    '''
+    """
     ret = {}
 
+    # Use the machine types as possible values
+    # Prefer 'kvm' over the others if available
     caps = capabilities(**kwargs)
-    hypervisors = sorted({x for y in [guest['arch']['domains'].keys() for guest in caps['guests']] for x in y})
-    default_hypervisor = 'kvm' if 'kvm' in hypervisors else hypervisors[0]
+    hypervisors = sorted(
+        {
+            x
+            for y in [guest["arch"]["domains"].keys() for guest in caps["guests"]]
+            for x in y
+        }
+    )
+    default_hypervisor = "kvm" if "kvm" in hypervisors else hypervisors[0]
 
     if not hypervisor:
-        hypervisor = __salt__['config.get']('libvirt:hypervisor')
-        if hypervisor is not None:
-            salt.utils.versions.warn_until(
-                'Sodium',
-                '\'libvirt:hypervisor\' configuration property has been deprecated. '
-                'Rather use the \'virt:connection:uri\' to properly define the libvirt '
-                'URI or alias of the host to connect to. \'libvirt:hypervisor\' will '
-                'stop being used in {version}.'
+        hypervisor = default_hypervisor
+    virtconf = __salt__["config.get"]("virt", {})
+    for typ in ["disk", "nic"]:
+        _func = getattr(sys.modules[__name__], "_{0}_profile".format(typ))
+        ret[typ] = {
+            "default": _func(
+                "default", hypervisor if hypervisor else default_hypervisor
             )
-        else:
-            # Use the machine types as possible values
-            # Prefer 'kvm' over the others if available
-            hypervisor = default_hypervisor
-    virtconf = __salt__['config.get']('virt', {})
-    for typ in ['disk', 'nic']:
-        _func = getattr(sys.modules[__name__], '_{0}_profile'.format(typ))
-        ret[typ] = {'default': _func('default', hypervisor)}
+        }
         if typ in virtconf:
             ret.setdefault(typ, {})
             for prf in virtconf[typ]:
-                ret[typ][prf] = _func(prf, hypervisor)
+                ret[typ][prf] = _func(
+                    prf, hypervisor if hypervisor else default_hypervisor
+                )
     return ret
 
 
 def shutdown(vm_, **kwargs):
-    '''
+    """
     Send a soft shutdown signal to the named vm
 
     :param vm_: domain name
@@ -2681,7 +3248,7 @@ def shutdown(vm_, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.shutdown <domain>
-    '''
+    """
     conn = __get_conn(**kwargs)
     dom = _get_domain(conn, vm_)
     ret = dom.shutdown() == 0
@@ -2690,7 +3257,7 @@ def shutdown(vm_, **kwargs):
 
 
 def pause(vm_, **kwargs):
-    '''
+    """
     Pause the named vm
 
     :param vm_: domain name
@@ -2709,7 +3276,7 @@ def pause(vm_, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.pause <domain>
-    '''
+    """
     conn = __get_conn(**kwargs)
     dom = _get_domain(conn, vm_)
     ret = dom.suspend() == 0
@@ -2718,7 +3285,7 @@ def pause(vm_, **kwargs):
 
 
 def resume(vm_, **kwargs):
-    '''
+    """
     Resume the named vm
 
     :param vm_: domain name
@@ -2737,7 +3304,7 @@ def resume(vm_, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.resume <domain>
-    '''
+    """
     conn = __get_conn(**kwargs)
     dom = _get_domain(conn, vm_)
     ret = dom.resume() == 0
@@ -2746,7 +3313,7 @@ def resume(vm_, **kwargs):
 
 
 def start(name, **kwargs):
-    '''
+    """
     Start a defined domain
 
     :param vm_: domain name
@@ -2765,7 +3332,7 @@ def start(name, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.start <domain>
-    '''
+    """
     conn = __get_conn(**kwargs)
     ret = _get_domain(conn, name).create() == 0
     conn.close()
@@ -2773,7 +3340,7 @@ def start(name, **kwargs):
 
 
 def stop(name, **kwargs):
-    '''
+    """
     Hard power down the virtual machine, this is equivalent to pulling the power.
 
     :param vm_: domain name
@@ -2792,7 +3359,7 @@ def stop(name, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.stop <domain>
-    '''
+    """
     conn = __get_conn(**kwargs)
     ret = _get_domain(conn, name).destroy() == 0
     conn.close()
@@ -2800,7 +3367,7 @@ def stop(name, **kwargs):
 
 
 def reboot(name, **kwargs):
-    '''
+    """
     Reboot a domain via ACPI request
 
     :param vm_: domain name
@@ -2819,7 +3386,7 @@ def reboot(name, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.reboot <domain>
-    '''
+    """
     conn = __get_conn(**kwargs)
     ret = _get_domain(conn, name).reboot(libvirt.VIR_DOMAIN_REBOOT_DEFAULT) == 0
     conn.close()
@@ -2827,7 +3394,7 @@ def reboot(name, **kwargs):
 
 
 def reset(vm_, **kwargs):
-    '''
+    """
     Reset a VM by emulating the reset button on a physical machine
 
     :param vm_: domain name
@@ -2846,7 +3413,7 @@ def reset(vm_, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.reset <domain>
-    '''
+    """
     conn = __get_conn(**kwargs)
     dom = _get_domain(conn, vm_)
 
@@ -2859,7 +3426,7 @@ def reset(vm_, **kwargs):
 
 
 def ctrl_alt_del(vm_, **kwargs):
-    '''
+    """
     Sends CTRL+ALT+DEL to a VM
 
     :param vm_: domain name
@@ -2878,7 +3445,7 @@ def ctrl_alt_del(vm_, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.ctrl_alt_del <domain>
-    '''
+    """
     conn = __get_conn(**kwargs)
     dom = _get_domain(conn, vm_)
     ret = dom.sendKey(0, 0, [29, 56, 111], 3, 0) == 0
@@ -2887,7 +3454,7 @@ def ctrl_alt_del(vm_, **kwargs):
 
 
 def create_xml_str(xml, **kwargs):  # pylint: disable=redefined-outer-name
-    '''
+    """
     Start a transient domain based on the XML passed to the function
 
     :param xml: libvirt XML definition of the domain
@@ -2906,7 +3473,7 @@ def create_xml_str(xml, **kwargs):  # pylint: disable=redefined-outer-name
     .. code-block:: bash
 
         salt '*' virt.create_xml_str <XML in string format>
-    '''
+    """
     conn = __get_conn(**kwargs)
     ret = conn.createXML(xml, 0) is not None
     conn.close()
@@ -2914,7 +3481,7 @@ def create_xml_str(xml, **kwargs):  # pylint: disable=redefined-outer-name
 
 
 def create_xml_path(path, **kwargs):
-    '''
+    """
     Start a transient domain based on the XML-file path passed to the function
 
     :param path: path to a file containing the libvirt XML definition of the domain
@@ -2933,19 +3500,18 @@ def create_xml_path(path, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.create_xml_path <path to XML file on the node>
-    '''
+    """
     try:
-        with salt.utils.files.fopen(path, 'r') as fp_:
+        with salt.utils.files.fopen(path, "r") as fp_:
             return create_xml_str(
-                salt.utils.stringutils.to_unicode(fp_.read()),
-                **kwargs
+                salt.utils.stringutils.to_unicode(fp_.read()), **kwargs
             )
     except (OSError, IOError):
         return False
 
 
 def define_xml_str(xml, **kwargs):  # pylint: disable=redefined-outer-name
-    '''
+    """
     Define a persistent domain based on the XML passed to the function
 
     :param xml: libvirt XML definition of the domain
@@ -2964,7 +3530,7 @@ def define_xml_str(xml, **kwargs):  # pylint: disable=redefined-outer-name
     .. code-block:: bash
 
         salt '*' virt.define_xml_str <XML in string format>
-    '''
+    """
     conn = __get_conn(**kwargs)
     ret = conn.defineXML(xml) is not None
     conn.close()
@@ -2972,7 +3538,7 @@ def define_xml_str(xml, **kwargs):  # pylint: disable=redefined-outer-name
 
 
 def define_xml_path(path, **kwargs):
-    '''
+    """
     Define a persistent domain based on the XML-file path passed to the function
 
     :param path: path to a file containing the libvirt XML definition of the domain
